#!/usr/local/bin/python
#
# create arc of a binary tree. Display and balance it

from bintree  import balance, delete, ids, insert, contains
from display  import drawStatic, drawTree, waitForButton, displayOff

def buildTree(sofar=None, values=[]) :
    if values :
       this = insert(sofar, values[0])
       return buildTree(this, values[1:]) 
    else : return sofar

def test() :
    bt = buildTree(values=[10,20,30,40,50,60,70,80,90])
    bt = balance(bt)
    #print(bt)

    origIds = ids(bt)
    drawStatic()
    while True :
        drawTree(bt, (300,50), 300,50, origIds)
        ans = waitForButton()
        if   ans == 'Balance' : bt = balance(bt)
        elif ans == 'Exit'    : break
        else :
            try :
                ans = int(ans)
                origIds = ids(bt)
                if contains(bt,ans) : bt = delete(bt,ans)
                else                : bt = insert(bt,ans)
            except: pass
    displayOff() 

if __name__ == "__main__" : test()
